VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form formCommunications 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Communications"
   ClientHeight    =   6900
   ClientLeft      =   1680
   ClientTop       =   1935
   ClientWidth     =   7680
   FillColor       =   &H80000000&
   ForeColor       =   &H00808080&
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   394.849
   ScaleMode       =   0  'User
   ScaleWidth      =   520.458
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   Begin VB.CommandButton Command3 
      Caption         =   "Command1"
      Height          =   375
      Left            =   8520
      TabIndex        =   12
      Top             =   3600
      Width           =   1215
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Command1"
      Height          =   375
      Left            =   8520
      TabIndex        =   11
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   8520
      TabIndex        =   10
      Top             =   2640
      Width           =   1215
   End
   Begin VB.Frame Frame4 
      Caption         =   "Imediate Command Input"
      Height          =   975
      Left            =   120
      TabIndex        =   8
      Top             =   5760
      Width           =   7455
      Begin VB.TextBox command 
         Height          =   375
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   6975
      End
   End
   Begin VB.Frame DeviceSelectionFrame 
      Caption         =   "Device Selection"
      Height          =   2175
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   7455
      Begin VB.CommandButton rescanDevices 
         Caption         =   "Re-Scan Devices"
         Height          =   375
         Left            =   240
         TabIndex        =   13
         Top             =   1560
         Width           =   2895
      End
      Begin VB.CommandButton LedOn 
         Caption         =   "Led On"
         Height          =   372
         Left            =   3600
         TabIndex        =   7
         Top             =   360
         Width           =   1215
      End
      Begin VB.CommandButton LedOff 
         Caption         =   "Led Off"
         Height          =   372
         Left            =   3600
         TabIndex        =   6
         Top             =   960
         Width           =   1215
      End
      Begin VB.CommandButton Reset 
         Caption         =   "Reset"
         Height          =   372
         Left            =   5280
         TabIndex        =   5
         Top             =   960
         Width           =   1215
      End
      Begin VB.CommandButton IdRequest 
         Caption         =   "Identity"
         Height          =   375
         Left            =   5280
         TabIndex        =   4
         Top             =   360
         Width           =   1215
      End
      Begin VB.ListBox DevicesList 
         Height          =   1035
         ItemData        =   "Form1.frx":0442
         Left            =   240
         List            =   "Form1.frx":0444
         TabIndex        =   3
         ToolTipText     =   "Select a device to talk to"
         Top             =   360
         Width           =   2895
      End
   End
   Begin VB.Timer TimerBackgound 
      Interval        =   100
      Left            =   3360
      Top             =   7080
   End
   Begin VB.Frame Frame5 
      Caption         =   "Communications Logging"
      Height          =   3255
      Left            =   120
      TabIndex        =   0
      Top             =   2400
      Width           =   7455
      Begin RichTextLib.RichTextBox Logbox 
         Height          =   2655
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   6975
         _ExtentX        =   12303
         _ExtentY        =   4683
         _Version        =   393217
         Enabled         =   -1  'True
         ScrollBars      =   2
         TextRTF         =   $"Form1.frx":0446
      End
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   2160
      Top             =   7080
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      CommPort        =   2
      DTREnable       =   -1  'True
      Handshaking     =   2
      InputLen        =   1
      OutBufferSize   =   32767
      RThreshold      =   1
      RTSEnable       =   -1  'True
      SThreshold      =   32767
   End
End
Attribute VB_Name = "formCommunications"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim message As String
'

Private Sub Form_Load()
    
    Devices_Scan
    
End Sub


Private Sub Devices_Scan()
    Dim devices As Long
    Dim S As String
    Dim device As Long
    
    devices = FT_GetDeviceCount

    DevicesList.Clear
    
    If devices = 0 Then
        DevicesList.AddItem "No devices found."
    Else
        For device = 0 To devices - 1
            'Log "Description : <" & FT_GetDeviceDescription(device) & ">     Serial number : <" & FT_GetDeviceSerialNumber(device) & ">"
            DevicesList.AddItem FT_GetDeviceSerialNumber(device)
        Next device
    End If

End Sub


Private Sub DevicesList_click()
    
    Dim ft_serial As String
    
    If FT_HANDLE > 0 Then FT_W32_CloseHandle FT_HANDLE
    
    ft_serial = FT_GetDeviceSerialNumber(DevicesList.ListIndex)
    FT_HANDLE = FT_OpenSerial(ft_serial)
    
    log "Device selected : " & ft_serial
    formMain.statusBar.Panels(1).Text = "Device selected : " & ft_serial
    
End Sub


Private Sub Form_Unload(cancel As Integer)
    formMain.communications.Checked = False
    viewCom = 0
End Sub


Private Sub command_KeyDown(keycode As Integer, shift As Integer)
    Select Case keycode
        Case vbKeyReturn
            send_comm (command.Text & vbCrLf)
            log ">" & command.Text
    End Select
End Sub


Private Sub IdRequest_Click()
    send_comm ("id" + vbCrLf)
End Sub


Private Sub LedOn_Click()
    send_comm ("led on" + vbLf)
End Sub


Private Sub LedOff_Click()
    send_comm ("led off" + vbLf)
End Sub


Private Sub rescanDevices_Click()
    Devices_Scan
End Sub


Private Sub Reset_Click()
    send_comm ("reset" + vbCrLf)
End Sub


Private Sub TimerBackgound_Timer()

    Dim rx_queue As Long, tx_queue As Long, status As Long
    Dim readok As Boolean, buff() As Byte, bytes_read As Long, overlap As FT_OVERLAPPED
    Dim command As String
    
    
    If FT_HANDLE <> 0 Then
    
        If viewAna = 1 Then
            command = ""
            For pin = 1 To 8
                If formAnalogLevels.CheckADC(pin).value Then
                    command = command + "adc " + Str(pin) + vbLf
                Else
                    formAnalogLevels.ADCbar(pin) = 0
                    formAnalogLevels.ADCLabel(pin).Caption = ""
                End If
            Next pin
            If command <> "" Then send_comm (command)
        End If
        
        FT_GetStatus FT_HANDLE, VarPtr(rx_queue), VarPtr(tx_queue), VarPtr(status)
        
        If rx_queue > 0 Then
        
            ReDim buff(rx_queue)
            readok = FT_W32_ReadFile(FT_HANDLE, VarPtr(buff(0)), rx_queue, VarPtr(bytes_read), 0)
            
            'Log "rx_queue : " & rx_queue
            
            If rx_queue = 1 And readok Then log ("byte : " & buff(0))
            
            If readok Then
                For n = 0 To bytes_read - 1
                    If buff(n) = Asc(vbLf) Or buff(n) = Asc(vbCr) Then
                        demux_message
                    Else
                        message = message + Chr(buff(n))
                    End If
                Next n
            End If
            
        End If
        
    End If
    
End Sub


Private Sub demux_message()
    
    Dim pin As Long, state As Long, color As Long, value As Long
    
    If message = "" Then Exit Sub
    
    words = Split(message)
    
    If words(0) = "pin" Then
        pin = Val(words(1))
        state = Val(words(2))
        If state = 0 Then color = LED_GREEN_LOW Else color = LED_GREEN_HI
        If pin_direction(pin) = 0 Then formDigitalPins.pin_led.Item(pin).FillColor = color
    End If

    If words(0) = "debounce" Then
            If words(2) = "count" And words(3) = "reset" Then
                edges_total = edges_total + Val(words(4))
                edges.Text = Str(edges_total)
            End If
    End If
    
    If words(0) = "adc" Then
        If message <> "adc" Then
            pin = Val(words(1))
            value = Val(words(2))
            formAnalogLevels.ADCbar(pin).value = value
            formAnalogLevels.ADCLabel(pin).Caption = value
            If formAnalogLevels.CheckADC(pin).value Then message = ""
        End If
    End If
    
    If message <> "" Then log "received : " & message: log ""
    
    message = ""
    
End Sub

